#ifndef _ABAKUS_RESULTLISTBOX_H
#define _ABAKUS_RESULTLISTBOX_H

#include <klistbox.h>

class KPopupMenu;
class QLabel;

class ResultListBox : public KListBox
{
    Q_OBJECT

    public:
    ResultListBox(QWidget *parent = 0, const char *name = "result list box");

    protected:
    virtual void mouseMoveEvent(QMouseEvent *e);
    virtual void mousePressEvent(QMouseEvent *e);
    virtual void mouseReleaseEvent(QMouseEvent *);
    virtual void contextMenuEvent(QContextMenuEvent *e);

    signals:
    void signalEntrySelected(const QString &text);
    void signalResultSelected(const QString &text);

    private slots:
    void slotDoubleClicked(QListBoxItem *item);

    private:
    QPixmap makePixmap(const QString &text);
    KPopupMenu *constructPopupMenu();

    bool m_dragging;
};

#endif
