/* Demonstration of the very simple math expression parser I've cooked up.
 * Distributed under the terms of the GNU General Public License, v2 (or any
 * later version).
 * Copyright (c) 2004 Michael Pyne <michael.pyne@kdemail.net>
 */
#include "function.h"
#include <stdio.h>
#include <string.h>

int paren_balance_level(const char *str)
{
    int level = 0;
    unsigned len, i;
    len = strlen(str);
    for(i = 0; i < len; ++i)
	if(str[i] == '(')
	    --level;
	else if(str[i] == ')')
	    ++level;

    return level;
}

int main(void)
{
    char buf[512] = { 0 };
    char parens[32] = { 0 };
    int i, level, slack;
    number_t result;

    printf ("Press Ctrl-C to quit.\n\n");

    for ( ; ; ) {
	printf ("Enter a string to parse: ");

	fgets(buf, 512, stdin);
	if(buf[strlen(buf) - 1] == '\n')
	    buf[strlen(buf) - 1] = 0;

	if(strcmp(buf, "degrees") == 0) {
	    setTrigMode(Abakus::Degrees);
	    continue;
	}

	if(strcmp(buf, "radians") == 0) {
	    setTrigMode(Abakus::Radians);
	    continue;
	}

	level = paren_balance_level(buf);
	if (level < 0)
	{
	    level = -level;
	    slack = 511 - strlen(buf);
	    if(slack > 31)
		slack = 31;
	    for (i = 0; i < level && i < slack; ++i)
		parens[i] = ')';
	    parens[i] = 0;
	    strcat(buf, parens);
	}

	result = parseString(buf);

	if(lastParseStatusResult() == 0)
	    printf ("The result was %.20Lg\n", result);
    }

    return 0;
}
